#include <bits/stdc++.h>

const int maxn = 1e5 + 10;

std::vector<int> graph[maxn];
int parent[maxn];
int timeIn[maxn], timeOut[maxn], timer;
bool isTaken[maxn], taken[maxn];
bool used[maxn];

void dfs(int v) {
    timeIn[v] = timer++;
    used[v] = true;
    for (int u : graph[v]) {
        if (!used[u]) {
            parent[u] = v;
            dfs(u);
        }
    }
    timeOut[v] = timer++;
}

bool isAncestor(int v, int u) {
    return timeIn[v] <= timeIn[u] && timeOut[u] <= timeOut[v];
}

int lca(int v, int u) {
    if (isAncestor(v, u)) {
        return v;
    }
    if (isAncestor(u, v)) {
        return u;
    }
    while (!isAncestor(v, u) && !isAncestor(u, v)) {
        v = parent[v];
    }
    return v;
}

int countTaken(int v, int u) {
    int answer = 0;
    int l = lca(v, u);
    while (v != l) {    
        answer += isTaken[v];
        v = parent[v];
    }
    while (u != l) {    
        answer += isTaken[u];
        u = parent[u];
    }
    answer += isTaken[l];
    return answer;
}

void calcTaken(int v) {
    isTaken[v] |= taken[v];
    for (int u : graph[v]) {
        if (u != parent[v]) {
            calcTaken(u);
            isTaken[v] |= isTaken[u];
        }
    }
}

int main() {
    freopen("occupation.in", "r", stdin);
    freopen("occupation.out", "w", stdout);

    int n, m;
    scanf("%d", &n);
    assert(n <= 2000);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;
        --y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    dfs(0);
    scanf("%d", &m);
    for (int i = 0; i < m; i++) {
        int type;
        scanf("%d", &type);
        if (type == 1) {
            int x;
            scanf("%d", &x);
            --x;
            taken[x] ^= true;
            int mn = 1e9, mx = -1;
            int mnInd = -1, mxInd = -1;
            for (int j = 0; j < n; j++) {
                if (taken[j] && timeIn[j] < mn) {
                    mn = timeIn[j];
                    mnInd = j;
                }
                if (taken[j] && timeIn[j] > mx) {
                    mx = timeIn[j];
                    mxInd = j;
                }
            }
            int v = lca(mnInd, mxInd);
            for (int j = 0; j < n; j++) {
                isTaken[j] = false;
            }
            calcTaken(v);
        } else {
            int x, y;
            scanf("%d%d", &x, &y);
            --x;
            --y;
            printf("%d\n", countTaken(x, y));
        }
    }
    return 0;
}
